# Prerequisites

- A Kubernetes Cluster
- Synthetic Data Generator Installed (Mandatory) [1]
- Prometheus Installed in the Kubernetes Cluster (Mandatory) [1]
- Be the Admin of the cluster, with access to the default Service Account.

# Description
The code in this repository is using all the different Images of the subcomponents from the CODECO PDLC Component. Using the bash files and a Kubernetes Cluster, an administrator can install the PDLC Subcomponents.

# Installation
Before you install PDLC you must specify the Cluster's Topology.

To specify the Topology go the the file `data_preprocessing/pdlc-dp-deployment.yaml` and in the field `topology.json` specify your topology using the Node Names and their perspective adjacency matrix. You can find an example in [1].

One more step you will need to do is to specify the node that PDLC is going to be deployed on. Go in the field `spec/spec/nodeName` in the following files and provide the name of your node:
- data_preprocessing/pdlc-dp-deployment.yaml
- context_awareness/pdlc-ca-deployment.yaml
- gnn_model/gnn_controller.yaml
- gnn_model/gnn_inference.yaml
- rl_model/rl-model-deployment.yaml

Run the following commands to use the installation script:
```
chmod -R 777 apply_yamls.sh
./apply_yamls.sh
```

## How to Uninstall PDLC
Run the following commands to use the deletion script:
```
chmod -R 777 remove_yamls.sh
./remove_yamls.sh
```

# References
1. [Syntetic Data Generator](https://gitlab.eclipse.org/eclipse-research-labs/codeco-project/experimentation-framework-and-demonstrations/data-generators-and-datasets/synthetic-data-generator)

# Authors:
- Panagiotis Karamolegkos (UPRC)
- Pepi Paraskevoulakou (UPRC)
