# Author: Panagiotis Karamolegkos (UPRC)
# chmod -R 777 apply_yamls.sh
# ./apply_yamls.sh

# Create the PDLC namespace
kubectl create namespace he-codeco-pdlc

# Install Storage Class for Persistent Volume Claim
kubectl apply -f ./volume/storage-class.yaml

# Install PVC for RW
kubectl apply -f ./volume/shared-pvc-rw.yaml
kubectl apply -f ./volume/shared-pv-rw.yaml

# Install PVC for RO
kubectl apply -f ./volume/shared-pvc-ro.yaml
kubectl apply -f ./volume/shared-pv-ro.yaml

# Install PDLC Containers
## Install DP Subcomponent
kubectl apply -f ./data_preprocessing/pdlc-dp-role.yaml
kubectl apply -f ./data_preprocessing/pdlc-dp-role-binding.yaml
kubectl apply -f ./data_preprocessing/pdlc-dp-deployment.yaml

## Install CA Subcomponent
kubectl apply -f ./context_awareness/pdlc-ca-deployment.yaml

## Install GNN Subcomponent
kubectl apply -f ./gnn_model/gnn-role.yaml
kubectl apply -f ./gnn_model/gnn-role-binding.yaml
kubectl apply -f ./gnn_model/gnn_inference.yaml
kubectl apply -f ./gnn_model/gnn_controller.yaml

## Install RL Subcomponent
kubectl apply -f ./rl_model/rl-model-deployment.yaml
